

BALLS2   call MAKETABS


BALLOOP  call EFFECT
         ei
         halt 
         call ACTION
         ld   a,(ENDSIGN)
         or   a
         jr   z,BALLOOP
         xor  a
         ld   (ENDSIGN),a
         ret

EFFECT   call CLS
         call DRAW
         call MOVEBALL
         ret


; zmaze virtual screen
CLS      ld   hl,VRAM2
         ld   de,VRAM2+1
         ld   bc,1535
         ld   (hl),0
         ldir
         ret

; posuva ballsy
; nacita suradnicu a posun a
; zrata to, ak nahodou som mimo
; obrazovky zneguje posun a 
; nahodi suradnicu okraja obrzu
MOVEBALL ld   hl,BLOBTAB
         ld   de,MOVETAB
         ld   b,(hl)
         inc  hl
MOVLP1   ld   a,(de)
         add  a,(hl)
         cp   128
         jr   c,MVOK1
         ld   a,(de)
         neg  
         ld   (de),a
         xor  a
         jp   MVOK2
         
; mam tu +4 aby sa to mohlo 
; dotknut spodneho kraja obrazu
; horneho nemoze, lebo to potom
; zapisuje do ROM (-4 == 252)
; slo by to spravit, ale naco?
MVOK1    cp   33+4
         jr   c,MVOK2
         ld   a,(de)
         neg  
         ld   (de),a
         ld   a,32+4
MVOK2    ld   (hl),a
         inc  de
         inc  hl
         
         
; tu sa spracuje xova suradnica
         ld   a,(de)
         add  a,(hl)
         cp   128
         jr   c,MVOK3
         ld   a,(de)
         neg  
         ld   (de),a
         xor  a
         jp   MVOK4
         
MVOK3    cp   25
         jr   c,MVOK4
         ld   a,(de)
         neg  
         ld   (de),a
         ld   a,24
MVOK4    ld   (hl),a
         inc  de
         inc  hl
         
         djnz MOVLP1
         ret  
         
         
         
; tu sa kreslia ballsy do 
; virtualnej VRAM
         
; stale sa pricitava hodnota
; z tabulky - vlastne spritu,
; ale miesto kreslenia ho 
; priratavam
DRAW     ld   hl,BLOBTAB
         ld   b,(hl)
         inc  hl
DLP1     xor  a
         ld   d,(hl)
         inc  hl
         rr   d
         rra  
         rr   d
         rra  
         rr   d
         rra  
         or   (hl)
         inc  hl
         ld   e,a
         push hl
         ld   hl,VRAM2
         add  hl,de
         ex   de,hl
; v de je teraz adresa laveho
; horneho rohu spritu
         ld   hl,BLOBMAP
         ld   a,16
DLP3     ex   af,af'
         ld   c,8
DLP2     ld   a,(de)
         add  a,(hl)
         ld   (de),a
         inc  de
         inc  l
         dec  c
         jr   nz,DLP2
         ld   a,e
         add  a,16+8
         ld   e,a
         ld   a,d
         adc  a,c
         ld   d,a
         ex   af,af'
         dec  a
         jp   nz,DLP3
         pop  hl
         djnz DLP1
         ret  
         
ACTSP    ld   sp,0
         ret  
         
;------------------------------
; toto vykresli virtual screen
; do normalneho screenu, vidis
; ako to vyzera, ale neni to 
; snad az take zle....
ACTION   ;ld   (ACTSP+1),sp
         ;ld   sp,VRAMTAB
         ld   ix,VRAMTAB
         ld   hl,VRAM2
LIMIT    ld   b,-4
; budu sa vykreslovat len tie
; body virtual screenu, ktore
; maju hodnotu >=4, ostatne nie
; je to presne to iste ako v 
; ditherovanych, ale tu nemam
; odtiene sivej, ale len monoch
ACTLOOP  ;pop  de
         ld   e,(ix+0)
         inc  ix
         ld   a,(ix+0)
         or   a
         ret  z
         inc  ix
         ld   d,a
         
; nemozem kreslit kazdej bodky,
; lebo mame len 3.5 Mhz... 
; takze sa kresli,ako sa kresli
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         inc  e
         
         ld   a,(hl)
         inc  l
         add  a,b
         sbc  a,a
         and  %11000000
         ld   c,a
         ld   a,(hl)
         inc  hl
         add  a,b
         sbc  a,a
         and  %00001100
         or   c
         ld   (de),a
         jp   ACTLOOP
         
         
MAKETABS ld   hl,VRAMTAB
         ld   de,18432+128+8+8
         ld   b,48
MTLP1    ld   (hl),e
         inc  hl
         ld   (hl),d
         inc  hl
         inc  d
         call DOWNDEBALL
         djnz MTLP1
         ld   (hl),b
         inc  hl
         ld   (hl),b
         ret  
         
DOWNDEBALL inc  d
         ld   a,d
         and  7
         ret  nz
         ld   a,e
         add  a,32
         ld   e,a
         ret  c
         ld   a,d
         sub  8
         ld   d,a
         ret  
         
         
         
         
         
         
; takto sa ballsy pohybuju,
; stale dy,dx pre vsetky sprity
; musi ich byt presne tolko,
; kolko je ballsov, inac to
; narobi slusny chaos
MOVETAB  defb 1,1
         defb 0,-1
         defb 1,0
         defb -2,1
         defb 0,1
         defb -1,0
         defb -1,-1
         defb 1,-2
         defb -1,-1
         defb 0,1
         defb -1,0
         defb 2,-1
         defb 0,-1
         defb 1,0
         defb 1,2
         defb -1,1
         
         
; tabulka suradnic ballsov, na
; zaciatku je pocet ballsov
         
; vsimni si dobre, je ich 16 a
; stale to frci! ;-)
BLOBTAB  defb 16
         defb 24,16
         defb 24,0
         defb 0,7
         defb 14,20
         defb 0,0
         defb 8,20
         defb 0,14
         defb 32,5
         defb 12,16
         defb 24,14
         defb 18,7
         defb 4,20
         defb 0,24
         defb 32,20
         defb 18,14
         defb 9,5
         
         
; takto vyzera jeden sprite
; je to to iste, ako bolo v
; ditherovanom efekte, ale 
; teraz je natiahnuty 2x po osi
; y, aby vykresleny vyzeral
; dobre (mam take divne interne
; rozlisenie, 32x48)
         defs 256-($%256)
BLOBMAP  defb 0,0,0,1,1,0,0,0
         defb 0,0,1,1,1,1,0,0
         defb 0,0,1,2,2,1,0,0
         defb 0,1,1,3,3,1,1,0
         defb 0,1,2,5,5,2,1,0
         defb 0,1,3,6,6,3,1,0
         defb 1,2,6,7,7,6,2,1
         defb 1,2,6,9,9,6,2,1
         defb 1,2,6,9,9,6,2,1
         defb 1,2,6,7,7,6,2,1
         defb 0,1,3,6,6,3,1,0
         defb 0,1,2,5,5,2,1,0
         defb 0,1,1,3,3,1,1,0
         defb 0,0,1,2,2,1,0,0
         defb 0,0,1,1,1,1,0,0
         defb 0,0,0,1,1,0,0,0
         
; tabulka adries VRAM + 2bajty
; na ukoncovaciu 0
         
;nezostali mi totiz volne 
; registre ziadne, takze nemam
; ako robit slucku v ACTION
VRAMTAB  defs 48*2+2
         
;         defs 256-($%256)
;VRAM2    defs 1536
;         defs 256
;VRAM2    equ $A000

; 256 naviac je pre istotu, aby
; som neprepisal to co netreba

;         end

